VERSION 5.00
Begin VB.Form Bytor 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "12/18/97   Engin's First Direct3D Project       (Thanks to Mr. Patrice Scribe)"
   ClientHeight    =   5760
   ClientLeft      =   1095
   ClientTop       =   1035
   ClientWidth     =   7695
   ClipControls    =   0   'False
   DrawMode        =   1  'Blackness
   FillColor       =   &H0000FFFF&
   FillStyle       =   2  'Horizontal Line
   LinkTopic       =   "&H80000001&"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   480
   ScaleMode       =   0  'User
   ScaleWidth      =   640
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   3360
      Top             =   2760
   End
End
Attribute VB_Name = "Bytor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' PS 07/18/98 :
' - Updated to run with DirectX5.tlb v 0.6
' - SetSearchPath added
' - ScreenWidth & ScreenHeight initialized depending upon the window size

Option Explicit

Const pi = 3.1415927
Dim D3DRM As IDirect3DRM
Dim Scene As IDirect3DRMFrame
Dim Camera As IDirect3DRMFrame
Dim Clipper As IDirectDrawClipper
Dim Device As IDirect3DRMDevice
Dim Viewport As IDirect3DRMViewPort
Dim LightFrame As IDirect3DRMFrame
Dim LightFrame2 As IDirect3DRMFrame
Dim WorldFrame As IDirect3DRMFrame
Dim Gloframe As IDirect3DRMFrame
Dim Light As IDirect3DRMLight
Dim light2 As IDirect3DRMLight
Dim corx As Single
Dim corz As Single
Dim GRADOS As Integer
Dim grado2 As Integer

Dim animframe As IDirect3DRMFrame
Dim CUBE As IDirect3DRMMeshBuilder
Dim CUBEFrame As IDirect3DRMFrame
Dim walls As IDirect3DRMMeshBuilder


Dim SKY As IDirect3DRMMeshBuilder

Dim valor As Integer
Dim Texture As IDirect3DRMTexture
Dim sceneheight As Integer
Dim screenheight As Integer
Dim screenwidth As Integer
Dim defaultheight As Integer
Dim defaultwidth As Integer
Dim zoom As Single

Dim anim As IDirect3DRMAnimationSet
Dim ticktock As Long


Sub Buildworld()
   
    
'--------SET UP OUR SCENE, WORLD AND CAMERA-----------------------------------------------

    Direct3DRMCreate D3DRM
    ' PS 07/18/98 : search path for textures
    D3DRM.SetSearchPath App.Path
    D3DRM.SetDefaultTextureColors 32
    D3DRM.CreateFrame Nothing, Scene
    D3DRM.CreateFrame Scene, WorldFrame
    D3DRM.CreateFrame WorldFrame, Camera
    Camera.SetPosition WorldFrame, 0, sceneheight, 0
    
    
'---------SET UP OUR LIGHTS -------------------------------------------------------------
   
    
    D3DRM.CreateFrame WorldFrame, LightFrame
    LightFrame.SetOrientation WorldFrame, 0.5, -1, 0.5, 0, 1, 0
    D3DRM.CreateLightRGB D3DRMLIGHT_DIRECTIONAL, 0.5, 1, 0.5, Light
    LightFrame.AddLight Light
    LightFrame.SetRotation Scene, 1, 0, 1, 0.1
    Set Light = Nothing
    
    D3DRM.CreateFrame WorldFrame, LightFrame2
    LightFrame2.SetOrientation WorldFrame, -0.5, -0.3, 1, 0, 1, 0
    D3DRM.CreateLightRGB D3DRMLIGHT_DIRECTIONAL, 0.5, 0.5, 1, light2
    LightFrame2.AddLight light2
    LightFrame2.SetRotation Scene, 0, 1, 1, 0.33
    Set light2 = Nothing
    
    Dim ambientlight As IDirect3DRMLight
    D3DRM.CreateLightRGB D3DRMLIGHT_AMBIENT, 0.7, 0.6, 0.5, ambientlight
    Scene.AddLight ambientlight
    Set ambientlight = Nothing
    
'-----------------------------------------------------------------------------------------
    
    
'------THIS IS USED IF YOU WERE TO LOAD AN ANIMATION USING CONV3DS.EXE WITH -Ax OPTION
   D3DRM.CreateFrame WorldFrame, animframe
   D3DRM.CreateAnimationSet anim
   anim.Load App.Path & "\yyz.x", 0, 0, 0, 0, animframe
   animframe.AddScale D3DRMCOMBINE_BEFORE, 2, 2, 2
   animframe.AddTranslation D3DRMCOMBINE_BEFORE, 20, 2, 0
   animframe.AddRotation D3DRMCOMBINE_BEFORE, 0, 1, 0, 90
   animframe.SetColorRGB 1, 1, 1
   animframe.SetZbufferMode D3DRMZBUFFER_ENABLE

'------------------------------------------------------------------------------------------
        
   
    D3DRM.CreateMeshBuilder walls
    walls.Load App.Path & "\dungeon.x", 0, 0, 0, 0
    walls.[Scale] 0.5, 0.5, 0.5
    walls.[Translate] 0, -1.5, 0
    walls.SetPerspective 1
    WorldFrame.AddVisual walls
    
    Set walls = Nothing
    
    
    D3DRM.CreateFrame WorldFrame, CUBEFrame
    D3DRM.CreateMeshBuilder CUBE
    CUBE.Load App.Path & "\box1.x", 0, 0, 0, 0
    CUBE.[Scale] 8, 8, 8
    CUBE.SetPerspective 0
    CUBE.[Translate] 5, 5, 0
    CUBEFrame.AddVisual CUBE
    CUBEFrame.SetRotation Scene, 0, 1, 0, 0.1
    
    Set CUBE = Nothing
    
    
'----------THIS STUFF HANDLES THE BACKGROUND LOOK------------------------------------------
    
   ' D3DRM.CreateMeshBuilder SKY
   ' SKY.Load App.Path & "\sky.x", 0, 0, 0, 0
   ' SKY.[Scale] 0.3, 0.3, 0.3
   ' SKY.SetPerspective 0
   ' WorldFrame.AddVisual SKY
    
   ' Set SKY = Nothing

  
   ' D3DRM.LoadTexture App.Path & "\m1.bmp", Texture
   ' Scene.SetSceneBackgroundImage Texture
    
    Scene.SetSceneFogEnable 1
    Scene.SetSceneFogMode D3DRMFOG_EXPONENTIAL
    Scene.SetSceneFogColor 270
    Scene.SetSceneBackground 270
    Scene.SetSceneFogParams 0, 330, 1
    Scene.SetZbufferMode D3DRMZBUFFER_ENABLE
    Scene.SetSortMode D3DRMSORT_FRONTTOBACK
       
    
    
    Set Texture = Nothing
    
    
    
   '------------------------------------------------------------------------------------------
    



End Sub



Private Static Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo Form_KeyDown_Error
        
    Select Case KeyCode
        
        Case vbKeyEscape
             Set WorldFrame = Nothing
             Set Scene = Nothing
             Set Camera = Nothing
             Set Viewport = Nothing
             Set Device = Nothing
             Set D3DRM = Nothing
             Set Clipper = Nothing
             End
        
        Case vbKeyLeft
            GRADOS = GRADOS - valor
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 1, 0, 0, -(grado2 * pi / 180)
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 0, 1, 0, -(valor * pi / 180)
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 1, 0, 0, (grado2 * pi / 180)
        
        Case vbKeyUp
            corx = corx + valor * Sin(GRADOS * pi / 180)
            corz = corz + valor * Cos(GRADOS * pi / 180)
            Camera.SetPosition Scene, corx, sceneheight, corz
        
        Case vbKeyRight
            GRADOS = GRADOS + valor
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 1, 0, 0, -(grado2 * pi / 180)
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 0, 1, 0, (valor * pi / 180)
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 1, 0, 0, (grado2 * pi / 180)
        
        Case vbKeyDown
            corx = corx - valor * Sin(GRADOS * pi / 180)
            corz = corz - valor * Cos(GRADOS * pi / 180)
            Camera.SetPosition Scene, corx, sceneheight, corz
        
        Case vbKeyPageDown
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 1, 0, 0, -(valor * pi / 180)
            grado2 = grado2 - valor
        
        Case vbKeyPageUp
            Camera.AddRotation D3DRMCOMBINE_BEFORE, 1, 0, 0, (valor * pi / 180)
            grado2 = grado2 + valor
        
        Case vbKeyA
             sceneheight = sceneheight + valor
             Camera.SetPosition Scene, corx, sceneheight, corz
        
        Case vbKeyZ
             sceneheight = sceneheight - valor
             Camera.SetPosition Scene, corx, sceneheight, corz
        
        Case vbKeyEnd
            corx = 0
            corz = -30
            sceneheight = 15
           
            Camera.SetOrientation Scene, 0, 0, 1, 0, 1, 0
            Camera.SetPosition Scene, 0, sceneheight, 0
            Camera.SetRotation Scene, 0, 0, 0, 0
            GRADOS = 0
            grado2 = 0
        
        Case vbKeyAdd
        
        defaultwidth = defaultwidth * 1.1
        defaultheight = defaultheight * 1.1
        If defaultwidth > screenwidth Then defaultwidth = screenwidth
        If defaultheight > screenheight Then defaultheight = screenheight
         
        Scene.SetSceneBackgroundRGB 0, 0, 0
        Viewport.Clear
        Viewport.Configure 0, 0, screenwidth, screenheight
        Scene.SetSceneBackgroundRGB 0.1, 0.1, 0.1
        Viewport.Configure (screenwidth - defaultwidth) / 2, (screenheight - defaultheight) / 2, defaultwidth, defaultheight
             
        Case vbKeySubtract
        
        defaultwidth = defaultwidth * 0.90909
        defaultheight = defaultheight * 0.90909
        If defaultwidth < 120 Then defaultwidth = 120
        If defaultheight < 90 Then defaultheight = 90
         
         Scene.SetSceneBackgroundRGB 0, 0, 0
         Viewport.Clear
         Viewport.Configure 0, 0, screenwidth, screenheight
         Scene.SetSceneBackgroundRGB 0.1, 0.1, 0.1
         Viewport.Configure (screenwidth - defaultwidth) / 2, (screenheight - defaultheight) / 2, defaultwidth, defaultheight
          
        
        Case Else
            Exit Sub
    
    End Select
    UpdateScreen
    Exit Sub

Form_KeyDown_Error:
    Debug.Print Now; " "; Err.Nuwallser; " "; Err.Description
    Set WorldFrame = Nothing
    Set Scene = Nothing
    Set Camera = Nothing
    Set Viewport = Nothing
    Set Device = Nothing
    Set D3DRM = Nothing
    Set Clipper = Nothing
    End

End Sub

Private Sub Form_Resize()
    If Not (Viewport Is Nothing) Then Set Viewport = Nothing
    If Not (Clipper Is Nothing) Then Set Clipper = Nothing
    DirectDrawCreateClipper 0, Clipper, Nothing
    Clipper.SetHWnd 0, hWnd
    
    D3DRM.CreateDeviceFromClipper Clipper, ByVal 0&, screenwidth, screenheight, Device
    D3DRM.CreateViewport Device, Camera, 0, 0, screenwidth, screenheight, Viewport


    Viewport.SetBack 400
    Viewport.Clear
    Viewport.Configure 0, 0, screenwidth, screenheight:
    Viewport.Configure (screenwidth - defaultwidth) / 2, (screenheight - defaultheight) / 2, defaultwidth, defaultheight:

    Device.SetDither 1
    Device.SetQuality D3DRMLIGHT_ON Or D3DRMFILL_SOLID Or D3DRMSHADE_PHONG

End Sub
Private Sub Form_Unload(Cancel As Integer)
    
    Set WorldFrame = Nothing
    Set Scene = Nothing
    Set Camera = Nothing
    Set Viewport = Nothing
    Set Device = Nothing
    Set D3DRM = Nothing
    Set Clipper = Nothing
    End

End Sub
Private Sub UpdateScreen()
    
On Error GoTo UpdateScreen_Error
    
    Viewport.Clear
    Scene.Move 1
    Viewport.Render Scene
    Device.Update
    
Exit Sub



UpdateScreen_Error:
        Set WorldFrame = Nothing
        Set Scene = Nothing
        Set Camera = Nothing
        Set Viewport = Nothing
        Set Device = Nothing
        Set D3DRM = Nothing
        Set Clipper = Nothing
End


End Sub

Private Sub Form_Load()
    
'--------SET OUR CONSTANTS----------------------------------------------------------------
    
    valor = 8
    sceneheight = 5
    ticktock = 0
    ' PS 07/18/98 : initial values changed
    screenwidth = ScaleX(ScaleWidth, ScaleMode, vbPixels) '640
    screenheight = ScaleY(ScaleHeight, ScaleMode, vbPixels) '480
    

    
    MsgBox ("Graphics by Engin    (12/16/97)")
    
    defaultwidth = screenwidth - 120
    defaultheight = screenheight - 80
    zoom = 1
   
   
    Buildworld  'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

'------------------------------------------------------------------------------------------

End Sub
Private Sub Timer1_Timer()
    
    ticktock = ticktock + 1
    anim.SetTime ticktock
    UpdateScreen
        
End Sub


